Overview | Package | Class | Tree | Deprecated | Index | Help
| J avolution v5.3 (J2SE 1.5+)
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javolution.xml.stream
Interface XMLStreamReader

All Superinterfaces:
  XMLStreamConstants

All Known Implementing Classes:
  XMLStreamReaderImpl

    public interface XMLStreamReader

extends XMLStreamConstants

This interface is similar to `javax.xml.stream.XMLStreamReader`; but it does not forces dynamic allocation when parsing (its methods returns `CharArray` instances instead of `String`).

Except for the speed (faster) and its real-time characteristics the usage/behavior is about the same as its StAX counterpart.

The `CharArray` instances returned by this reader supports fast primitive conversions as illustrated below:``

         // Creates a new reader (potentially recycled).
         XMLInputFactory factory = XMLInputFactory.newInstance();
         XMLStreamReader reader = factory.createXMLStreamReader(inputStream);

         while (reader.getEventType() != XMLStreamConstants.END_DOCUMENT) {
             switch (reader.next()) {
                 case XMLStreamConstants.START_ELEMENT:
                 if (reader.getLocalName().equals("Time")) {
                      // Reads primitive types (int) attributes directly (no memory allocation).
                      time.hour = reader.getAttributeValue(null, "hour").toInt();
                      time.minute = reader.getAttributeValue(null, "minute").toInt();
                      time.second = reader.getAttributeValue(null, "second").toInt();
                 }
                 ...
                 break;
             }
         }

         reader.close(); // Recycles the reader.
         inputStream.close(); // Underlying stream has to be closed explicitly.

Version:
  4.0, September 4, 2006
Author:
  Jean-Marie Dautelle

Field Summary

Fields inherited from interface javolution.xml.stream.XMLStreamConstants
`ATTRIBUTE, CDATA, CHARACTERS, COMMENT, DTD, END_DOCUMENT, END_ELEMENT, ENTITY_DECLARATION, ENTITY_REFERENCE, NAMESPACE, NOTATION_DECLARATION, PROCESSING_INSTRUCTION, SPACE, START_DOCUMENT, START_ELEMENT`

Method Summary
`void` | `close()` Frees any resources associated with this Reader.
`int` | `getAttributeCount()` Returns the count of attributes on this START_ELEMENT, this method is only valid on a START_ELEMENT or ATTRIBUTE.
`CharArray` | `getAttributeLocalName(int index)` Returns the localName of the attribute at the provided index.
`CharArray` | `getAttributeNamespace(int index)` Returns the namespace of the attribute at the provided index
`CharArray` | `getAttributePrefix(int index)` Returns the prefix of this attribute at the provided index
`CharArray` | `getAttributeType(int index)` Returns the XML type of the attribute at the provided index.
`CharArray` | `getAttributeValue(java.lang.CharSequence namespaceURI, java.lang.CharSequence localName)` Returns the normalized attribute value of the attribute with the namespace and localName.
`CharArray` | `getAttributeValue(int index)` Returns the value of the attribute at the index.
`CharArray` | `getCharacterEncodingScheme()` Returns the character encoding declared on the xml declaration.
`CharArray` | `getElementText()` Reads the content of a text-only element, an exception is thrown if this is not a text-only element.
`java.lang.String` | `getEncoding()` Returns the input encoding if known or `null` if unknown.
`int` | `getEventType()` Returns an integer code that indicates the type of the event the cursor is pointing to.
`CharArray` | `getLocalName()` Returns the (local) name of the current event.
`Location` | `getLocation()` Return the current location of the processor.
`NamespaceContext` | `getNamespaceContext()` Returns a read only namespace context for the current position.
`int` | `getNamespaceCount()` Returns the count of namespaces declared on this START_ELEMENT or END_ELEMENT.
`CharArray` | `getNamespacePrefix(int index)` Returns the prefix for the namespace declared at the index.
`CharArray` | `getNamespaceURI()` If the current event is a START_ELEMENT or END_ELEMENT this method returns the URI of the current element (URI mapping to the prefix element/attribute has; or if no prefix `null`).
`CharArray` | `getNamespaceURI(java.lang.CharSequence prefix)` Returns the uri for the given prefix.
`CharArray` | `getNamespaceURI(int index)` Returns the URI for the namespace declared at the index.
`CharArray` | `getPIData()` Get the data section of a processing instruction.
`CharArray` | `getPITarget()` Returns the target of a processing instruction.
`CharArray` | `getPrefix()` Returns the prefix of the current event or null if the event does not have a prefix.
`java.lang.Object` | `getProperty(java.lang.String name)` Gets the value of a feature/property from the underlying implementation
`CharArray` | `getText()` Returns the current value of the parse event as a string, this returns the string value of a CHARACTERS event, returns the value of a COMMENT, the replacement value for an ENTITY_REFERENCE, the string value of a CDATA section, the string value for a SPACE event, or the String value of the internal subset of the DTD.
`char[]` | `getTextCharacters()` Returns an array which contains the characters from this event.
`int` | `getTextCharacters(int sourceStart, char[] target, int targetStart, int length)` Gets the the text associated with a CHARACTERS, SPACE or CDATA event.
`int` | `getTextLength()` Returns the length of the sequence of characters for this Text event within the text character array.
`int` | `getTextStart()` Returns the offset into the text character array where the first character (of this text event) is stored.
`CharArray` | `getVersion()` Gets the xml version declared on the xml declaration.
`boolean` | `hasName()` Indicates if the current event has a name (is a START_ELEMENT or END_ELEMENT).
`boolean` | `hasNext()` Returns true if there are more parsing events and false if there are no more events.
`boolean` | `hasText()` Indicates if the current event has text.
`boolean` | `isAttributeSpecified(int index)` Indicates if this attribute was created by default.
`boolean` | `isCharacters()` Indicates if the cursor points to character data.
`boolean` | `isEndElement()` Indicates if the cursor points to an end tag.
`boolean` | `isStandalone()` Gets the standalone declaration from the xml declaration.
`boolean` | `isStartElement()` Indicates if the cursor points to a start tag.
`boolean` | `isWhiteSpace()` Indicates if the cursor points to character data that consists of all whitespace.
`int` | `next()` Gets next parsing event - contiguous character data is returned into a single chunk.
`int` | `nextTag()` Skips any white space (isWhiteSpace() returns true), COMMENT, or PROCESSING_INSTRUCTION, until a START_ELEMENT or END_ELEMENT is reached.
`void` | `require(int type, java.lang.CharSequence namespaceURI, java.lang.CharSequence localName)` Tests if the current event is of the given type and if the namespace and name match the current namespace and name of the current event.
`boolean` | `standaloneSet()` Checks if standalone was set in the document.

Method Detail

### getProperty

    java.lang.Object getProperty(java.lang.String name)
                                 throws java.lang.IllegalArgumentException

  Gets the value of a feature/property from the underlying implementation

  Parameters:
    `name` - the name of the property.
  Returns:
    the value of the property.
  Throws:
    `java.lang.IllegalArgumentException`

### next

    int next()
             throws XMLStreamException

  Gets next parsing event - contiguous character data is returned into a single chunk. By default entity references must be expanded and reported transparently to the application. An exception will be thrown if an entity reference cannot be expanded. If element content is empty (i.e. content is "") then no CHARACTERS event will be reported.

  Given the following XML:
  <foo><!--description-->content text<![CDATA[<greeting>Hello</greeting>]]>other content</foo>
  The behavior of calling next() when being on foo will be:
  1- the comment (COMMENT)
  2- then the characters section (CHARACTERS)
  3- then the CDATA section (another CHARACTERS)
  4- then the next characters section (another CHARACTERS)
  5- then the END_ELEMENT

  NOTE: empty element (such as <tag/>) will be reported with two separate events: START_ELEMENT, END_ELEMENT - This preserves parsing equivalency of empty element to <tag></tag>. This method will throw an IllegalStateException if it is called after hasNext() returns false.

  Returns:
    the integer code corresponding to the current parse event
  Throws:
    `NoSuchElementException` - if this is called when hasNext() returns false
    `XMLStreamException` - if there is an error processing the underlying XML source

### require

    void require(int type,
                 java.lang.CharSequence namespaceURI,
                 java.lang.CharSequence localName)
                 throws XMLStreamException

  Tests if the current event is of the given type and if the namespace and name match the current namespace and name of the current event. If the namespaceURI is null it is not checked for equality, if the localName is null it is not checked for equality.

  Parameters:
    `type` - the event type.
    `namespaceURI` - the uri of the event, may be null.
    `localName` - the localName of the event, may be null.
  Throws:
    `XMLStreamException` - if the required values are not matched.

### getElementText

    CharArray getElementText()
                             throws XMLStreamException

  Reads the content of a text-only element, an exception is thrown if this is not a text-only element. Regardless of the value of javax.xml.stream.isCoalescing this method always returns coalesced content.
  Precondition: the current event is START_ELEMENT.
  Postcondition: the current event is the corresponding END_ELEMENT.
  The method does the following (implementations are free to optimized but must do equivalent processing):

       if (getEventType() != XMLStreamConstants.START_ELEMENT) {
              throw new XMLStreamException(
                              "parser must be on START_ELEMENT to read next text", getLocation());
       }
       int eventType = next();
       StringBuffer content = new StringBuffer();
       while (eventType != XMLStreamConstants.END_ELEMENT) {
              if (eventType == XMLStreamConstants.CHARACTERS
                              || eventType == XMLStreamConstants.CDATA
                              || eventType == XMLStreamConstants.SPACE
                              || eventType == XMLStreamConstants.ENTITY_REFERENCE) {
                      buf.append(getText());
              } else if (eventType == XMLStreamConstants.PROCESSING_INSTRUCTION
                              || eventType == XMLStreamConstants.COMMENT) {
                      // skipping
              } else if (eventType == XMLStreamConstants.END_DOCUMENT) {
                      throw new XMLStreamException(
                                      "unexpected end of document when reading element text content",
                                      this);
              } else if (eventType == XMLStreamConstants.START_ELEMENT) {
                      throw new XMLStreamException(
                                      "element text content may not contain START_ELEMENT",
                                      getLocation());
              } else {
                      throw new XMLStreamException("Unexpected event type " + eventType,
                                      getLocation());
              }
              eventType = next();
       }
       return buf.toString();

  Throws:
    `XMLStreamException` - if the current event is not a START_ELEMENT or if a non text element is encountered.

### nextTag

    int nextTag()
                throws XMLStreamException

  Skips any white space (isWhiteSpace() returns true), COMMENT, or PROCESSING_INSTRUCTION, until a START_ELEMENT or END_ELEMENT is reached. If other than white space characters, COMMENT, PROCESSING_INSTRUCTION, START_ELEMENT, END_ELEMENT are encountered, an exception is thrown. This method should be used when processing element-only content seperated by white space.
  Precondition: none
  Postcondition: the current event is START_ELEMENT or END_ELEMENT and cursor may have moved over any whitespace event.
  Essentially it does the following (implementations are free to optimized but must do equivalent processing):

         int eventType = next();
         while((eventType == XMLStreamConstants.CHARACTERS && isWhiteSpace()) // skip whitespace
         || (eventType == XMLStreamConstants.CDATA && isWhiteSpace())
         // skip whitespace
         || eventType == XMLStreamConstants.SPACE
         || eventType == XMLStreamConstants.PROCESSING_INSTRUCTION
         || eventType == XMLStreamConstants.COMMENT
         ) {
         eventType = next();
         }
         if (eventType != XMLStreamConstants.START_ELEMENT && eventType != XMLStreamConstants.END_ELEMENT) {
         throw new String XMLStreamException("expected start or end tag", getLocation());
         }
         return eventType;

  Returns:
    the event type of the element read (START_ELEMENT or END_ELEMENT)
  Throws:
    `XMLStreamException` - if the current event is not white space, PROCESSING_INSTRUCTION, START_ELEMENT or END_ELEMENT
    `NoSuchElementException` - if this is called when hasNext() returns false

### hasNext

    boolean hasNext()
                    throws XMLStreamException

  Returns true if there are more parsing events and false if there are no more events. This method will return false if the current state of the XMLStreamReader is END_DOCUMENT.

  Returns:
    true if there are more events, false otherwise.
  Throws:
    `XMLStreamException` - if there is a fatal error detecting the next state.

### close

    void close()
               throws XMLStreamException

  Frees any resources associated with this Reader. This method does not close the underlying input source.

  Throws:
    `XMLStreamException` - if there are errors freeing associated resources

### getNamespaceURI

    CharArray getNamespaceURI(java.lang.CharSequence prefix)

  Returns the uri for the given prefix. The uri returned depends on the current state of the processor.

  NOTE:The 'xml' prefix is bound as defined in Namespaces in XML specification to "http://www.w3.org/XML/1998/namespace".

  NOTE: The 'xmlns' prefix must be resolved to following namespace http://www.w3.org/2000/xmlns/

  Parameters:
    `prefix` - the prefix to lookup.
  Returns:
    the uri bound to the given prefix or `null` if it is not bound

### isStartElement

    boolean isStartElement()

  Indicates if the cursor points to a start tag.

  Returns:
    `true` if the cursor points to a start tag; `false` otherwise.

### isEndElement

    boolean isEndElement()

  Indicates if the cursor points to an end tag.

  Returns:
    `true` if the cursor points to a end tag; `false` otherwise.

### isCharacters

    boolean isCharacters()

  Indicates if the cursor points to character data.

  Returns:
    `true` if the cursor points to character data; `false` otherwise.

### isWhiteSpace

    boolean isWhiteSpace()

  Indicates if the cursor points to character data that consists of all whitespace.

  Returns:
    `true` if the cursor points to whitespaces; `false` otherwise.

### getAttributeValue

    CharArray getAttributeValue(java.lang.CharSequence namespaceURI,
                                java.lang.CharSequence localName)

  Returns the normalized attribute value of the attribute with the namespace and localName.

  Parameters:
    `namespaceURI` - the namespace of the attribute or `null`.
    `localName` - the local name of the attribute.
  Returns:
    returns the value of the attribute or `null`.
  Throws:
    `java.lang.IllegalStateException` - if not a START_ELEMENT or ATTRIBUTE.

### getAttributeCount

    int getAttributeCount()

  Returns the count of attributes on this START_ELEMENT, this method is only valid on a START_ELEMENT or ATTRIBUTE. This count excludes namespace definitions. Attribute indices are zero-based.

  Returns:
    returns the number of attributes.
  Throws:
    `java.lang.IllegalStateException` - if not a START_ELEMENT or ATTRIBUTE.

### getAttributeNamespace

    CharArray getAttributeNamespace(int index)

  Returns the namespace of the attribute at the provided index

  Parameters:
    `index` - the position of the attribute.
  Returns:
    the namespace URI or `null` if no prefix.
  Throws:
    `java.lang.IllegalStateException` - if not a START_ELEMENT or ATTRIBUTE.

### getAttributeLocalName

    CharArray getAttributeLocalName(int index)

  Returns the localName of the attribute at the provided index.

  Parameters:
    `index` - the position of the attribute.
  Returns:
    the localName of the attribute.
  Throws:
    `java.lang.IllegalStateException` - if not a START_ELEMENT or ATTRIBUTE.

### getAttributePrefix

    CharArray getAttributePrefix(int index)

  Returns the prefix of this attribute at the provided index

  Parameters:
    `index` - the position of the attribute.
  Returns:
    the prefix of the attribute or `null` if no prefix.
  Throws:
    `java.lang.IllegalStateException` - if not a START_ELEMENT or ATTRIBUTE.

### getAttributeType

    CharArray getAttributeType(int index)

  Returns the XML type of the attribute at the provided index.

  Parameters:
    `index` - the position of the attribute
  Returns:
    the XML type of the attribute.
  Throws:
    `java.lang.IllegalStateException` - if not a START_ELEMENT or ATTRIBUTE.

### getAttributeValue

    CharArray getAttributeValue(int index)

  Returns the value of the attribute at the index.

  Parameters:
    `index` - the position of the attribute.
  Returns:
    the attribute value.
  Throws:
    `java.lang.IllegalStateException` - if not a START_ELEMENT or ATTRIBUTE.

### isAttributeSpecified

    boolean isAttributeSpecified(int index)

  Indicates if this attribute was created by default.

  Parameters:
    `index` - the position of the attribute.
  Returns:
    `true` if this is a default attribute; `false` otherwise.
  Throws:
    `java.lang.IllegalStateException` - if not a START_ELEMENT or ATTRIBUTE.

### getNamespaceCount

    int getNamespaceCount()

  Returns the count of namespaces declared on this START_ELEMENT or END_ELEMENT. This method is only valid on a START_ELEMENT, END_ELEMENT or NAMESPACE. On an END_ELEMENT the count is of the namespaces that are about to go out of scope. This is the equivalent of the information reported by SAX callback for an end element event.

  Returns:
    returns the number of namespace declarations on this specific element.
  Throws:
    `java.lang.IllegalStateException` - if not a START_ELEMENT or END_ELEMENT.

### getNamespacePrefix

    CharArray getNamespacePrefix(int index)

  Returns the prefix for the namespace declared at the index.

  Parameters:
    `index` - the position of the namespace declaration.
  Returns:
    returns the namespace prefix or `null` if no prefix.
  Throws:
    `java.lang.IllegalStateException` - if this is not a START_ELEMENT, END_ELEMENT or NAMESPACE.

### getNamespaceURI

    CharArray getNamespaceURI(int index)

  Returns the URI for the namespace declared at the index.

  Parameters:
    `index` - the position of the namespace declaration.
  Returns:
    returns the namespace uri or `null` if no prefix.
  Throws:
    `java.lang.IllegalStateException` - if this is not a START_ELEMENT, END_ELEMENT or NAMESPACE.

### getNamespaceContext

    NamespaceContext getNamespaceContext()

  Returns a read only namespace context for the current position.

  Returns:
    return a namespace context

### getEventType

    int getEventType()

  Returns an integer code that indicates the type of the event the cursor is pointing to.

  Returns:
    the event type.

### getText

    CharArray getText()

  Returns the current value of the parse event as a string, this returns the string value of a CHARACTERS event, returns the value of a COMMENT, the replacement value for an ENTITY_REFERENCE, the string value of a CDATA section, the string value for a SPACE event, or the String value of the internal subset of the DTD. If an ENTITY_REFERENCE has been resolved, any character data will be reported as CHARACTERS events.

  Returns:
    the current text or `null`
  Throws:
    `java.lang.IllegalStateException` - if this state is not a valid text state.

### getTextCharacters

    char[] getTextCharacters()

  Returns an array which contains the characters from this event. This array should be treated as read-only and transient. I.e. the array will contain the text characters until the XMLStreamReader moves on to the next event. Attempts to hold onto the character array beyond that time or modify the contents of the array are breaches of the contract for this interface.

  Returns:
    the current text or an empty array.
  Throws:
    `java.lang.IllegalStateException` - if this state is not a valid text state.

### getTextCharacters

    int getTextCharacters(int sourceStart,
                          char[] target,
                          int targetStart,
                          int length)
                          throws XMLStreamException

  Gets the the text associated with a CHARACTERS, SPACE or CDATA event. Text starting a "sourceStart" is copied into "target" starting at "targetStart". Up to "length" characters are copied. The number of characters actually copied is returned. The "sourceStart" argument must be greater or equal to 0 and less than or equal to the number of characters associated with the event. Usually, one requests text starting at a "sourceStart" of 0. If the number of characters actually copied is less than the "length", then there is no more text. Otherwise, subsequent calls need to be made until all text has been retrieved. For example: `int length = 1024; char[] myBuffer = new char[ length ]; for ( int sourceStart = 0 ; ; sourceStart += length ) { int nCopied = stream.getTextCharacters( sourceStart, myBuffer, 0, length ); if (nCopied < length) break; }` XMLStreamException may be thrown if there are any XML errors in the underlying source. The "targetStart" argument must be greater than or equal to 0 and less than the length of "target", Length must be greater than 0 and "targetStart + length" must be less than or equal to length of "target".

  Parameters:
    `sourceStart` - the index of te first character in the source array to copy
    `target` - the destination array
    `targetStart` - the start offset in the target array
    `length` - the number of characters to copy
  Returns:
    the number of characters actually copied
  Throws:
    `XMLStreamException` - if the XML source is not well-formed.
    `java.lang.IndexOutOfBoundsException` - if targetStart < 0 or > than the length of target
    `java.lang.IndexOutOfBoundsException` - if length < 0 or targetStart + length > length of target
    `java.lang.UnsupportedOperationException` - if this method is not supported.

### getTextStart

    int getTextStart()

  Returns the offset into the text character array where the first character (of this text event) is stored.

  Throws:
    `java.lang.IllegalStateException` - if this state is not a valid text state.

### getTextLength

    int getTextLength()

  Returns the length of the sequence of characters for this Text event within the text character array.

  Throws:
    `java.lang.IllegalStateException` - if this state is not a valid text state.

### getEncoding

    java.lang.String getEncoding()

  Returns the input encoding if known or `null` if unknown.

  Returns:
    the encoding of this instance or null.

### hasText

    boolean hasText()

  Indicates if the current event has text. The following events have text: CHARACTERS, DTD ,ENTITY_REFERENCE, COMMENT, SPACE.

  Returns:
    `true` if the current event as text; `false` otherwise.

### getLocation

    Location getLocation()

  Return the current location of the processor. If the Location is unknown the processor should return an implementation of Location that returns -1 for the location and null for the publicId and systemId. The location information is only valid until next() is called.

  Returns:
    the current location.

### getLocalName

    CharArray getLocalName()

  Returns the (local) name of the current event. For START_ELEMENT or END_ELEMENT returns the (local) name of the current element. For ENTITY_REFERENCE it returns entity name. The current event must be START_ELEMENT or END_ELEMENT, or ENTITY_REFERENCE.

  Returns:
    the localName.
  Throws:
    `java.lang.IllegalStateException` - if this not a START_ELEMENT, END_ELEMENT or ENTITY_REFERENCE

### hasName

    boolean hasName()

  Indicates if the current event has a name (is a START_ELEMENT or END_ELEMENT).

  Returns:
    `true` if the current event has a name; `false` otherwise.

### getNamespaceURI

    CharArray getNamespaceURI()

  If the current event is a START_ELEMENT or END_ELEMENT this method returns the URI of the current element (URI mapping to the prefix element/attribute has; or if no prefix `null`).

  Returns:
    the URI bound to this elements prefix or `null`.
  Throws:
    `java.lang.IllegalStateException` - if not a START_ELEMENT, END_ELEMENT or ATTRIBUTE.

### getPrefix

    CharArray getPrefix()

  Returns the prefix of the current event or null if the event does not have a prefix.

  Returns:
    the prefix or `null`
  Throws:
    `java.lang.IllegalStateException` - if not a START_ELEMENT or END_ELEMENT.

### getVersion

    CharArray getVersion()

  Gets the xml version declared on the xml declaration.

  Returns:
    the XML version or `null`

### isStandalone

    boolean isStandalone()

  Gets the standalone declaration from the xml declaration.

  Returns:
    `true` if this is standalone; `false` otherwise.

### standaloneSet

    boolean standaloneSet()

  Checks if standalone was set in the document.

  Returns:
    `true` if standalone was set; `false` otherwise.

### getCharacterEncodingScheme

    CharArray getCharacterEncodingScheme()

  Returns the character encoding declared on the xml declaration.

  Returns:
    the encoding declared in the document or `null`

### getPITarget

    CharArray getPITarget()

  Returns the target of a processing instruction.

  Returns:
    the target.
  Throws:
    `java.lang.IllegalStateException` - if the current event is not a `XMLStreamConstants.PROCESSING_INSTRUCTION`

### getPIData

    CharArray getPIData()

  Get the data section of a processing instruction.

  Returns:
    the data (if processing instruction has any) or `null` if the processing instruction only has target.
  Throws:
    `java.lang.IllegalStateException` - if the current event is not a `XMLStreamConstants.PROCESSING_INSTRUCTION`

Overview | Package | Class | Tree | Deprecated | Index | Help
| J avolution v5.3 (J2SE 1.5+)
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2005 - 2009 Javolution.